
#include "webkit_util.h"



/*
    Send a vector of ints and strings and this function will create a webkit_message for you.
    Note: The return webkit_message pointer must be freed
*/
webkit_message* webkit_util::wrapMessage(int en, std::vector<int> args1, std::vector<std::string> args2){

    webkit_message *s;
    std::string t;
    int total_len_of_string = 0;
    int latest_len;
    //Calculate the total len of string first
    for(unsigned int i=0;i<args1.size(); i++){

        t = std::to_string(args1[i]);
        total_len_of_string += strlen(&t[0]) + 1;

    }
    for(unsigned int i=0;i<args2.size(); i++){

        total_len_of_string += strlen(&(args2[i])[0]) + 1;

    }

    s = (webkit_message*)malloc(sizeof(webkit_message) + total_len_of_string );
    s->func_name = en;
    s->total_int_args = args1.size();
    s->total_string_args = args2.size();
    s->total_len_of_string = total_len_of_string;

    latest_len = 0;

    //Fill the integers in s->serialized_arg
    for(int i=0;i<s->total_int_args;i++){
        
        t = std::to_string(args1[i]);
        strcpy(s->serialized_arg + latest_len, t.c_str());
        latest_len += strlen(&t[0]);
        s->serialized_arg[latest_len++]  = '\0';

    }

    //Fill the strings in s->serialized_arg
    for(int i=0;i<s->total_string_args;i++){

        t = args2[i];
        strcpy(s->serialized_arg + latest_len, t.c_str());
        latest_len += strlen(&t[0]);
        s->serialized_arg[latest_len++] = '\0';

    }

    assert(latest_len == total_len_of_string);
    return s;

}



/*
Args 
    start - Start at index start
    str[] - String that needs to be parsed
    buf   - Buffer memory, Should be initialized and destoryed outside.
*/

std::string webkit_util::parseNextString(int &start, char str[], char *&buf)
{

    memset(buf, 0, BUFSIZE);
    int buf_index = 0;

    int i;
    for (i = start; str[i] != '\0'; i++)
    {
        buf[buf_index] = str[i];
        buf_index++;
    }

    //Append with '\0'
    buf[buf_index] = str[i];
    buf_index++;

    //Increment the current pointer to s.serialized_arg
    start = start + buf_index;

    std::string ret(buf);
    return ret;
}

int webkit_util::parseNextInt(int &start, char str[], char *&buf)
{

    memset(buf, 0, BUFSIZE);
    int buf_index = 0;
    int ret;
    int i;
    for (i = start; str[i] != '\0'; i++)
    {

        buf[buf_index] = str[i];
        buf_index++;
    }

    buf[buf_index] = str[i];
    buf_index++;

    start = start + buf_index;
    sscanf(buf, "%d", &ret);
    return ret;
}
